<?php
class CACHEDB {
 var $req;
 var $dbh;

 var $default_db_server, $default_db_name, $default_db_group;
 var $default_postfix;

 var $md5_postfix;
 var $use_subseconds;

 const MYSQL_ER_BAD_DB_ERROR = 1049;
 const MYSQL_ER_NO_SUCH_TABLE = 1146;
 const MYSQL_ER_DUP_ENTRY = 1062;

 const TYPE_AUTO = 0;
 const TYPE_MINMAX = 1;
 const TYPE_MEAN = 2;
 const TYPE_ALL = 3;

 const NEED_COUNT = 1;		// Element count
 const TABLE_INFO = 2;		// Information about cache tables

 function __construct(SOURCERequest &$props) {
    global $ADEI_DB;

    $this->req = &$props;

    $this->dbh = mysql_connect($ADEI_DB['host'] . ($ADEI_DB['port']?(":" . $ADEI_DB['port']):""), $ADEI_DB['user'], $ADEI_DB['password']);
    if (!$this->dbh) throw new ADEIException(translate("Connection to the Caching MySQL Server is failed"));
    
    mysql_query("SET time_zone = '+0:00'");

    if (!@mysql_select_db($ADEI_DB['database'], $this->dbh)) {
		// ER_NO_DB_ERROR
	if (mysql_errno($this->dbh) == CACHEDB::MYSQL_ER_BAD_DB_ERROR) { 
	    if (mysql_query("CREATE DATABASE " . $ADEI_DB['database'], $this->dbh)) {
		if (!mysql_select_db($ADEI_DB['database'], $this->dbh))
		    throw new ADEIException(translate("Connection to the Caching MySQL Database is failed") . " (" . mysql_error($this->dbh) . ")");
	    } else 
		throw new ADEIException(translate("Creation of the caching MySQL database is failed") . " (" . mysql_error($this->dbh) . ")");
	    
	    
	} else 
	    throw new ADEIException(translate("Connection to the Caching MySQL Database is failed") . " (" . mysql_error($this->dbh) . ")");
    }

    if (isset($this->req->props['db_server']))
	$this->default_db_server = $this->req->props['db_server'];
    else 
	$this->default_db_server = false;
    if (isset($this->req->props['db_name']))
	$this->default_db_name =  $this->req->props['db_name'];
    else 
	$this->default_db_name = false;
    if (isset($this->req->props['db_group']))
	$this->default_db_group = $this->req->props['db_group'];
    else 
	$this->default_db_group = false;
    
    if (($this->default_db_server !== false)&&($this->default_db_name !== false)&&($this->default_db_group !== false)) {
	$this->default_postfix = $this->GetCachePostfix();	
    }

    $this->default_postfix = false;
 }

 function ListCachedGroups($db_name = false, $db_server = false) {
	// DS, only listing databases having level0 CACHE
    if ((!$db_server)||(!$db_name)) {
	if (!$db_server) $db_server = $this->default_db_server;
	if (!$db_name) $db_name = $this->default_db_name;

	if ((!$db_server)||(!$db_name))
	    throw new ADEIException(translate("Server name and database should be specified to list available groups"));
    }

    $groups = array();
    
    $prefix = "cache0__" . $db_server . "__" . $db_name . "__";
    $prefix_length = strlen($prefix);
    
    $res = @mysql_query("SHOW TABLES LIKE 'cache0__${db_server}__${db_name}%'", $this->dbh);
    if (!$res)
	throw new ADEIException(translate("SHOW TABLES request is failed on CACHE database, error: %s", mysql_error($this->dbh)));
	
    while ($row = mysql_fetch_row($res))
	array_push($groups, substr($row[0], $prefix_length));
    
    
    $md5 = array();
    $res = mysql_query("SHOW TABLES LIKE 'cache0__md5_%'", $this->dbh);
    while ($row = mysql_fetch_row($res))
	array_push($md5, substr($row[0], 6));
    
    if (sizeof($md5) > 0) {
	$prefix = "__" . $db_server . "__" . $db_name . "__";
	$prefix_length = strlen($prefix);

	$res = mysql_query("SELECT `hash`, `postfix` FROM md5 WHERE postfix LIKE '__${db_server}__${db_name}__%'", $this->dbh);
	if (!$res) 
	    throw new ADEIException(translate("SELECT request on MD5 table is failed, error: %s", mysql_error($this->dbh)));

	while ($row = mysql_fetch_row($res)) {
	    if (in_array($row[0], $md5))
		array_push($groups, substr($row[1], $postfix_length));
	}

	return array_unique($groups);
    }
    
    return $groups;    
 }

 function GetGroupPostfix($db_group = false, $db_name = false, $db_server = false) {
    if ((!$db_server)||(!$db_name)||(!$db_group)) {
	if ($db_server === false) $db_server = $this->default_db_server;
	if ($db_name === false) $db_name = $this->default_db_name;
	if ($db_group === false) $db_group = $this->default_db_group;
	if (($db_server === false)||($db_name === false)||($db_group === false))
	    throw new ADEIException(translate("Server name, database and group is required to construct CACHE postfix"));
    }

    $db_group = preg_replace("/[^\w\d_]/","",$db_group);
    
    return "__${db_server}__${db_name}__${db_group}";
 }    

 function MD5CreateTable() {
    if (!@mysql_query("CREATE TABLE `md5` (`hash` CHAR(64) PRIMARY KEY,  `postfix` VARCHAR(4096) NOT NULL, UNIQUE INDEX(postfix(64)))", $this->dbh)) {
	throw new ADEIException(translate("Creation of system tables (md5) within CACHE database is failed") . " (" . mysql_error($this->dbh) . ")");
    }
 }

 function MD5CreateEntry($postfix) {
    $query = "INSERT INTO `md5` VALUES('" . $this->default_postfix . "' , '" . mysql_real_escape_string($postfix) . "')";
    if (!@mysql_query($query, $this->dbh)) 
	throw new ADEIException(translate("Can not insert entry into the MD5 caching table, error") . ": " . mysql_error($this->dbh));
 }

 function MD5Check() {
    $res = @mysql_query("SELECT `postfix` from `md5` WHERE `hash` = '" . $this->default_postfix . "'", $this->dbh);
    if (!$res) {
	switch (mysql_errno($this->dbh)) {
	    case CACHE::MYSQL_ER_NO_SUCH_TABLE:
		$this->MD5CreateTable();
		$row = false;
	    break;
	    default:
		throw new ADEIException(translate("Can not query CACHE md5 table, error") . ": " . mysql_error($this->dbh));
	}
	
    } else {
	$row = mysql_fetch_row($res);
    }
    
    $postfix = $this->GetGroupPostfix();

    if ($row === false) 
	$this->MD5CreateEntry($postfix);
    elseif (strcmp($row[0], $postfix))
	throw new ADEIException(translate("Unlucky, the MD5 checksums of two groups (\"%s\" and \"%s\") are coinciding. This is not handled automaticaly yet. Please, add/alter md5 suffix to the newly added group.", $row[0], $postfix));
 }


 function GetCachePostfix($db_group = false, $db_name = false, $db_server = false) {
    $postfix = $this->GetGroupPostfix($db_group, $db_name, $db_server);

    if (isset($this->md5_postfix)) $md5 = $this->md5_postfix;
    else $md5 = $this->req->GetCustomOption('use_md5_postfix', $db_server, $db_name, $db_group);
    
    if ($md5) {
	return "__md5_" . (is_string($md5)?$md5:"") .  md5($postfix);
    } else return $postfix;
 }
 
 function SetDefaultPostfix($postfix = false) {
    if ($postfix) $this->default_postfix = $postfix;
    else {
	$this->default_postfix = $this->GetCachePostfix();
    }
 }
 
 function GetTableName($resolution = 0, $postfix = false) {
    return "cache" . $resolution . ($postfix?$postfix:$this->default_postfix);
 }

 function DetectSubseconds($postfix = false) {
    $table = $this->GetTableName(0, $postfix);
    $res = mysql_query("SHOW COLUMNS FROM $table", $this->dbh);
    if (!$res)
        throw new ADEIException("There is problem executing 'SHOW COLUMNS' request on CACHE table '$table'");
    
    mysql_fetch_array($res); 		// skipping time column
    $row = mysql_fetch_array($res);	// possibly ns column
    if (!strcmp($row[0],"ns")) {
	if (!$postfix) $this->use_subseconds = true;
	return true;
    }

    if (!$postfix) $this->use_subseconds = false;
    return false;
 }
 
 function GetCacheWidth($postfix = false) {
    $table = $this->GetTableName(0, $postfix);

    $res = mysql_query("SHOW COLUMNS FROM $table", $this->dbh);
    if (!$res)
        throw new ADEIException("There is problem executing 'SHOW COLUMNS' request on CACHE table '$table'");

    while ($col = mysql_fetch_array($res)) $lastcol = &$col['Field'];

    if (!preg_match("/(\d+)/", $lastcol, $m)) 
        throw new ADEIException("There is problem finding out the number of channels. Last cache column is '$lastcol'");
	
    return ($m[1] + 1);
 }
 
 function GetCacheIDs($postfix = false) {
	// DS, check if we do not have a level0 CACHE
	$size = $this->GetCacheWidth($postfix);
	
	$ids = array();
	for ($i=0;$i<$size;$i++) array_push($ids, $i);

	return $ids;
 }

 function CreateCacheInterval($postfix = false, array &$iinfo = NULL, $flags = 0) {
    if (!$iinfo) {
	if ($this->req instanceof DATARequest)
	    $iinfo = $this->req->GetIntervalInfo();
    }

    $ivl = new INTERVAL($iinfo, NULL, NULL, $flags);
    $ivl->ApplyCache($this);

    return $ivl;
 }
 
 function CreateInterval(array &$iinfo = NULL, $flags = 0) {
    return $this->CreateCacheInterval(false, $iinfo, $flags);
 }

 function CreateCacheMask($postfix = false, array &$minfo = NULL, $flags = 0) {
    if (!$minfo) {
	if ($this->req instanceof GROUPRequest)
	    $minfo = $this->req->GetMaskInfo();
    }
    
    $mask = new MASK($minfo);
    if (!$mask->ids) $mask->ids = $this->GetCacheIDs($postfix);
    return $mask;
 }

 function CreateMask(array &$minfo = NULL, $flags = 0) {
    return $this->CreateCacheMask(false, $minfo, $flags);
 }

 function GetTableInfo($resolution = 0, $postfix = false, $flags = 0) {
    $table = $this->GetTableName($resolution, $postfix);
    
    $req = "UNIX_TIMESTAMP(MIN(time)) AS first, UNIX_TIMESTAMP(MAX(time)) AS last";
    if ($flags&CACHEDB::NEED_COUNT) $req .= ", COUNT(time) AS records";

    $res = mysql_query("SELECT $req FROM `$table`", $this->dbh);
    if (!$res) {
	switch (mysql_errno($this->dbh)) {
	    case CACHE::MYSQL_ER_NO_SUCH_TABLE:
		return false;
	    break;
	    default:
		throw new ADEIException("SELECT request '$req' on CACHE table '$table' is failed...");
	}
    }
    return mysql_fetch_assoc($res);
 }
 
 function GetCacheInfo($postfix = false, $flags = 0) {
	// DS, check if we do not have a level0 CACHE
    return $this->GetTableInfo(0, $postfix, $flags);
 }

 function GetInfo($flags = 0) {
    return $this->GetCacheInfo(false, $flags);
 } 

 function GetCacheItemList($postfix = false, MASK &$mask = NULL, $flags = 0) {
    $items = array();
    
    if (($mask)&&($mask->ids)) {
	foreach ($mask->ids as $i => $id) {
	    $items[$i] = array(
		"id" => $id,
		"name" =>  "Channel" . ($id+1),
	    );
	}
    } else {
        $size = $this->GetCacheWidth($postfix);

	for ($i=0;$i<$size;$i++) {
	    $items[$i] = array(
		"id" => $i,
		"name" =>  "Channel" . ($i+1),
	    );
	}
    }
    
    return $items;
 }

 function GetItemList(MASK &$mask = NULL, $flags = 0) {
    return $this->GetCacheItemList(false, $mask, $flags);
 }
 
 function SQLTime($time) {
    return strftime("%Y%m%d%H%M%S", floor($time));

/* 
    Subseconds are not supported by MySQL Datetime type
    if (is_int($time))
	return strftime("%Y%m%d%H%M%S", $time);
    else {
	return strftime("%Y%m%d%H%M%S", floor($time)) . substr(sprintf("%.6F", $time - floor($time)), 1);
    }
*/
 }
 
 function CreateTable($resolution, $items, $postfix = false) {
    if (($this instanceof CACHE) == false)
	throw new ADEIException(translate("CreateTable calls are only allowed on CACHE object"));

    $name = $this->GetTableName($resolution, $postfix);
    
    if ($resolution > 0) {
	for ($i = 0; $i < $items; $i++)
	    $query .= ", `min" . $i . "` DOUBLE, `max" . $i . "` DOUBLE, `mean" . $i . "` DOUBLE";

	/*, `duration` INT, `complete` BOOL,*/
	if (!mysql_query("CREATE TABLE `$name` (`time` DATETIME PRIMARY KEY, `n` BIGINT, `missing` INT" .  $query . ")", $this->dbh)) {
	    throw new ADEIException(translate("Unable to create cache table, error") . ": " . mysql_error($this->dbh));
	}
    } else {	
	for ($i = 0; $i < $items; $i++)
	    $query .= ", `v" . $i . "` DOUBLE";

	if ($this->use_subseconds) {
	    $time = "`time` DATETIME, `ns` INT, `subcache` INT";
	    $index = ", PRIMARY KEY (`time`, `ns`, `subcache`)";
	} else {
	    $time = "`time` DATETIME PRIMARY KEY";
	    $index = "";
	}
	
	if (!mysql_query("CREATE TABLE `$name` ($time"  .  $query . "$index)", $this->dbh)) {
	    throw new ADEIException(translate("Unable to create cache table, error") . ": " . mysql_error($this->dbh) . " [" . "CREATE TABLE `$name` ($time"  .  $query . ",$index)" . "]");
	}
    }
 }

 function CreateQuery($table, $time, &$d) {
    if (($this instanceof CACHE) == false)
	throw new ADEIException(translate("CreateTable calls are only allowed on CACHE object"));

    if (is_object($d)) {
	$sqltime = $this->SQLTime((int)$time);
#	echo "Time: $time -> $sqltime\n";
        
	$query = "INSERT INTO `$table` VALUES ($sqltime, " . $d->n . ", " . $d->missing;
	if ($d->n > 0) {
	    for ($j = 0; $j < $this->items; $j++) {
		$query .= ", " . $d->min[$j] . ", " . $d->max[$j] . ", " . $d->mean[$j];
	    }
	} else {
	    for ($j = 0; $j < $this->items; $j++) {
		$query .= ", 0, 0, 0";
	    }
	}
	$query .= ")";
    } else {
	$sqltime = $this->SQLTime($time);

	if ($this->use_subseconds) {
	    $point = strstr($time, ".");
	    if ($point) {
		$subs = substr($point, 1);
		$chars = strlen($subs);
		if ($chars<9) $subs .= str_repeat("0", 9 - $chars);
		$ns = ", $subs";
	    } else $ns = ", 0";
		// Subcache Information
	    $ns .= ", 0";
	} else $ns="";
	    
	$query = "INSERT INTO `$table` VALUES ($sqltime" . $ns;
	foreach ($d as $val) {
	    $query .= ", $val";
	}
	$query .= ")";
    }

    return $query;
 }

 function Insert($resolution, &$query) {
    if (($this instanceof CACHE) == false)
	throw new ADEIException(translate("CreateTable calls are only allowed on CACHE object"));

    if (!@mysql_query($query, $this->dbh)) {
	switch (mysql_errno($this->dbh)) {
	     case CACHE::MYSQL_ER_NO_SUCH_TABLE:
		$this->CreateTable($resolution, $this->items);
		if (!@mysql_query($query, $this->dbh)) {
		    throw new ADEIException(translate("Can not query caching table (Resolution: $resolution), error") . ": " . mysql_error($this->dbh));
		}
	     break;
	     case CACHE::MYSQL_ER_DUP_ENTRY:
	        if (!strstr($query, "cache0"))
		    throw new ADEIException(translate("Internal error. Trying to insert the block wich is already in the cache (Resolution: $resolution)."));
	        return CACHE::MYSQL_ER_DUP_ENTRY;
	     break;
	     default:
		throw new ADEIException(translate("Can not query caching table (Resolution: $resolution), error") . ": " . mysql_error($this->dbh));
	}
    }
 
    return 0;
 }

 function GetReady($table, $from, $to) {
    return new CACHEData($this, $table, $from, $to);
 }

 
 function GetCachePoints($postfix = false, MASK &$mask = NULL, INTERVAL &$ivl = NULL, $type = CACHEDB::TYPE_AUTO, $limit = 0, $amount = 0, $resolution = false) {
    if (!$mask) $mask = $this->CreateCacheMask();
    if (!$ivl) $ivl = $this->CreateCacheInterval();

    if ($type == CACHEDB::TYPE_ALL)
	$res = new RAWPoint($this, $mask, $ivl, $limit);
    else {
	$res = new DATAPoint($this, $mask, $ivl, $type, is_int($amount)?$amount:0, is_int($limit)?$limit:0, $resolution);
    }

    if (($postfix)||(!isset($this->use_subseconds))) {
	// we should find subsecond precision
    	$use_subseconds = $this->DetectSubseconds($postfix);
	$res->SetOption("use_subseconds", $use_subseconds);

	if ($postfix) $res->SetOption("postfix", $postfix);
    }
    return $res;    
 }
}

?>