<?php

class LOCK {
 var $lockf;
 
 const BLOCK = 1;
 
 function __construct($name) {
    global $TMP_PATH;
    global $SETUP;
    
    $dir = $TMP_PATH . "/locks";

    if (!is_dir($dir)) {
	if (!@mkdir($dir, 0755, true)) 
	    throw new ADEIException(translate("It is not possible to create lock directory \"$dir\""));
    }
    
    if ($SETUP) $fname = $dir . "/${SETUP}__${name}.lock";
    else $fname = $dir . "/ADEI__${name}.lock";

    $this->lockf = @fopen($fname, "a+");
    if (!$this->lockf)
	throw new ADEIException(translate("It is not possible to create lock file \"$fname\""));
 }

 function __destruct() {
    fclose($this->lockf);
 }
 
 function Lock($flag = 0, $errmsg = false) {
    if ($flag&LOCK::BLOCK) {
	$res = flock($this->lockf, LOCK_EX);
        if (!$res) {
	    if ($errmsg) throw new ADEIException($errmsg);
	    else throw new ADEIException(translate("Locking is failed"));
	}
    } else {
	$res = flock($this->lockf, LOCK_EX|LOCK_NB);
        if ((!$res)&&($errmsg)) throw new ADEIException($errmsg);
    }
    
    return $res;
 }
 
 function UnLock() {
    flock($this->lockf, LOCK_UN);
 }
}


?>