function ADEI(sidebar_id, menu_id, session_id) {
    this.config = new CONFIG;
    this.module = new MODULE(null, configSetupModule, this.config);
    this.popup = new POPUP(Geometry, null);

    this.updater = new UPDATER(this.config, this.module, this.popup);

    if (menu_id) this.menu = new MENU(this.config, this.updater, menu_id);
    else this.menu = null;
    
    this.source = null;
    this.source_interval = null;
    this.source_window = null;
    
    this.data_export = null;
    this.graph = null;
    
    this.options = null;
    
    this.cfg = new Object({
	'window_border': 10,
	'parse_delay': 100,
	'subsecond_threshold': 0,
	'zoom_ratio': 2,
	'query': null
    });
    
    if (typeof session_id == "undefined")
	this.adei_session = Math.floor(Math.random() * 4294967295);
    else
	this.adei_session = session_id;

    this.AddToQuery('adei_session=' + session_id);
    
    this.sidebar_node = document.getElementById(sidebar_id);

/*
    this.key = false;
    Ext.EventManager.addListener(document, "keyup", this.keyUp, this);
    Ext.EventManager.addListener(document, "keydown", this.keyDown, this);
    Ext.EventManager.addListener(document, "keypress", this.keyPress, this);    
*/
}

/*
ADEI.prototype.keyPress = function(ev) {
    ev.stopEvent();
}

ADEI.prototype.keyUp = function(ev) {
    this.key = false;
    ev.stopEvent();
}

ADEI.prototype.keyDown = function(ev) {
    this.key = ev.getKey();
    ev.stopEvent();
}
*/

ADEI.prototype.SetOptions = function(opts) {
    this.options = opts;
}

ADEI.prototype.SetProperty = function(name, val) {
    this.cfg[name] = val;
}

ADEI.prototype.AddToQuery = function(props) {
    if (this.cfg['query']) this.cfg['query'] += '&' + props;
    else this.cfg['query'] = props;
}

ADEI.prototype.RegisterModule = function(mod, mod_class) {
    this.module.Register(mod, mod_class);
}

ADEI.prototype.AttachSourceModule = function(source, ivl, wnd) {
    this.source = source;
    this.source_interval = ivl;
    this.source_window = wnd;

    source.AttachConfig(this.config);
    source.Init(this.updater, this.options);

    if (this.menu) this.menu.AttachWindow(wnd);
}

ADEI.prototype.AttachExportModule = function(data_export) {
    this.data_export = data_export;

    data_export.AttachConfig(this.config);    
    data_export.Init();
    
    if (this.menu) this.menu.AttachExporter(data_export);
}

ADEI.prototype.AttachGraphModule = function(graph) {
    this.graph = graph;

    graph.AttachConfig(this.config);    
    graph.AttachWindow(this.source_window);
    graph.AttachExporter(this.data_export);
}

ADEI.prototype.Start = function(mod, update_rate) {
    this.module.Open(mod);
    this.menu.Load();
    this.updater.Start(update_rate);
}

ADEI.prototype.OpenModule = function(mod) {
    this.module.Open(mod);
}

ADEI.prototype.SwitchPopup = function(mod) {
    this.popup.Switch(mod);
}

ADEI.prototype.UpdateModuleGeometry = function(mod, width, height) {
    var m = this.module.GetModule(mod);
    if ((m)&&(typeof m.AdjustGeometry != "undefined"))
        m.AdjustGeometry(width - this.sidebar_node.offsetWidth, height);
}

ADEI.prototype.GetURL = function(page, props) {
    if (this.cfg.query) {
	if (props) return page + "?" + this.cfg.query + "&" + props;
	return page + "?" + this.cfg.query;
    } else {
	if (props) return page + "?" + props;
	return page;
    }
}

ADEI.prototype.GetServiceURL = function(name, props) {
    return this.GetURL("services/" + name + ".php", props);
}

ADEI.prototype.GetService = function(name, props) {
    return this.GetServiceURL(name, props);
}

