function GRAPH(id, selid) {
    this.config = null;
    this.window = null;
    this.exporter = null;
    this.selector = document.getElementById(selid);
    this.frame = document.getElementById(id);
    
    this.start_xy = [ 0, 0 ];
    this.margins = { left: 0, top: 0, right: 0, bottom: 0 };
    this.crop_margins = { left: 0, top: 0, right: 0, bottom: 0 };
    this.allWidth = 10;
    this.allHeight = 10;
    
    this.height = 0;
    this.width = 0;
    
    if (this.frame) {
	this.img = this.frame.getElementsByTagName('img')[0];
    } else {
	this.frame = null;
    }
    
/*    
    Event.observe(id,'click',this.MouseStart);
    Event.observe(id,'MouseMove', this.MouseStart);
    Event.observe(id,'MouseDown', this.MouseStart);
*/

    this.crop = null;

    if (this.img) {
	Event.observe(this.img, 'load', this.Configure.bindAsEventListener(this));
    } else {
	if (this.frame) alert('The "img" element is not found within specified block "' + id + '"');
	else alert('GRAPH is not able to locate specified ("' + id + '") element');
    }

    this.LegendCloseBind = this.LegendClose.bindAsEventListener( this );
    this.LegendCloseHelperBind = eventCanceler.bindAsEventListener();
}

GRAPH.prototype.AttachConfig = function(config) {
    this.config = config;
//    config.Register(this);
}

GRAPH.prototype.Clear = function() {
    if (this.crop) {
	this.crop.clear();
    }
}


GRAPH.prototype.onEndCrop = function (self) {
    return function( coords, dimensions ) {
	if (self.window) {
	    if ((dimensions.width < self.allWidth)&&(dimensions.height < self.allHeight)) {
		self.window.SetCustomWindow(0, 0, 0, 0);
    	    } else if (dimensions.height < self.allHeight) {
		var xmin = self.xmin + (self.xmax - self.xmin)*(coords.x1 - self.margins.left) / self.real_width;
		var xmax = self.xmin + (self.xmax - self.xmin)*(coords.x2 - self.margins.left) / self.real_width;
		self.window.SetCustomWindow(xmin, xmax, 0, 0);
	    } else if (dimensions.width < self.allWidth) {
		var ymin = self.ymax - (self.ymax - self.ymin)*(coords.y2 - self.margins.top) / self.real_height;
		var ymax = self.ymax - (self.ymax - self.ymin)*(coords.y1 - self.margins.top) / self.real_height;
		self.window.SetCustomWindow(0, 0, ymin, ymax);
	    } else {
		var ymin = self.ymax - (self.ymax - self.ymin)*(coords.y2 - self.margins.top) / self.real_height;
		var ymax = self.ymax - (self.ymax - self.ymin)*(coords.y1 - self.margins.top) / self.real_height;
		var xmin = self.xmin + (self.xmax - self.xmin)*(coords.x1 - self.margins.left) / self.real_width;
		var xmax = self.xmin + (self.xmax - self.xmin)*(coords.x2 - self.margins.left) / self.real_width;
		self.window.SetCustomWindow(xmin, xmax, ymin, ymax);
	    }
	}
    }
	    
}

GRAPH.prototype.onCancelCrop = function (self) {
    return function() {
	if (self.window) {
	    self.window.SetCustomWindow(0,0,0,0);
//	    self.window.SetCustomWindow(self.config.from, self.config.to, self.config.win_min, self.config.win_max);
	}
    }
}

GRAPH.prototype.onApply = function (self) {
    return function ( coords, dimensions ) {
	self.window.Apply();
	self.crop.clear();
    }
}

GRAPH.prototype.onSave = function (self) {
    return function ( coords, dimensions ) {
	if (self.exporter) 
	    self.exporter.Export(true);
	else
	    adeiReportError("Data Exporter is not registered", "GRAPH");
    }
}

GRAPH.prototype.onMouseScroll = function (self) {
    return function ( delta, point ) {
//	alert(adei.key);
	if (delta > 0)
	    self.window.ZoomOut(point.x, point.y);
	else if (delta < 0)
	    self.window.ZoomIn(point.x, point.y);
    }
}



GRAPH.prototype.LegendClose = function(self) {
    return function(ev) {
	if (self.legend) {
	    self.legend.Hide();
	    self.legend = null;
	}
	Event.stop(ev);
    }
}

GRAPH.prototype.ShowLegend = function (self, mouse_x, mouse_y) {
    return function(transport) {
	if (transport.responseText.charAt(0) == '{') {
	    var json = transport.responseText.evalJSON(false);
    	    if (json.error) {
		alert(json.error);
	    } else {
		var html = "";//"<h4>Legend</h4>""<div class=\"window_close\"></div><h4>Legend</h4>";
		if ((json.legend)&&(json.legend.length>0)) {
		    html+="<table><tr><th>ID</th><th>Name</th></tr>";
		    for (var i = 0; i < json.legend.length; i++) {
			var item = json.legend[i];
			html+="<tr><td>" + item.id + "</td><td>" + item.name + "</td></tr>";
		    }
		    html+="</table>";
		} else {
		    html+="<p>Nothing selected</p>";
		}
		
		if ((self.legend)&&(self.legend.CheckReusability())) {
		    self.legend.AlterContent(html);
		} else {
		    var legend = new DIALOG(self.LegendClose(self), "Legend", html, "legend");
		    legend.Show(self.frame, self.legend, mouse_x, mouse_y);
		    self.legend = legend;
		}
	    }
	} else {
	    // XML
	}
    }
}

GRAPH.prototype.onClick = function (self) {
    return function ( ev, point ) {

	var point = {
	    xmin: self.xmin.toString(),
	    xmax: self.xmax.toString(),
	    ymin: self.ymin,
	    ymax: self.ymax,
	    x : adeiMathPreciseAdd(self.xmin, self.xsize*(point.x - self.margins.left) / self.real_width),
	    y : self.ymax - (self.ymax - self.ymin)*(point.y - self.margins.top) / self.real_height
	};
	
//	alert(self.xmax + " - " + self.xmin + "(" + self.xsize + "): " + point.x + "\n");
	
	new Ajax.Request(adei.GetServiceURL("legend"), 
	{
	    method: 'post',
	    requestHeaders: {Accept: 'application/json'},
	    parameters: { props: self.config.GetJSON(point) },
	    onSuccess: self.ShowLegend(self, ev.clientX, ev.clientY),
	    onFailure: function() {
		alert('GetLegend request is failed');
	    }
	});
    
	//updater.
    }
}


GRAPH.prototype.AttachWindow = function (window) {
    this.window = window;
    window.RegisterGraph(this);
}

GRAPH.prototype.AttachExporter = function (exporter) {
    this.exporter = exporter;
}

GRAPH.prototype.SetMargins = function (l,t,r,b) {
    this.margins = { left: l, top: t, right: r, bottom: b };
    this.crop_margins = { left: l, top: t, right: r, bottom: b };
}

GRAPH.prototype.SetAllSizes = function (w,h) {
    this.allWidth = w;
    this.allHeight = h;
}

GRAPH.prototype.Prepare = function() {
	// Fixing IE6.
    var diff = document.body.offsetWidth - windowGetWidth();
    if (diff > 0) {
	var new_size = this.frame.offsetWidth - diff;
	if (new_size > 0) {
	    this.config.SetupGeometry(new_size, this.frame.offsetHeight);
	    return;
	}
    }
    
    this.config.SetupGeometry(this.frame);
}

GRAPH.prototype.Configure = function() {
		this.real_height = this.img.height - this.margins.top - this.margins.bottom;
		this.real_width = this.img.width - this.margins.left - this.margins.right;
	    
		if (this.crop) {
		    var new_width = this.img.width;
		    var new_height = this.img.height;
		    
		    if ((new_width != this.width)||(new_height != this.height)) {
			this.width = new_width;
			this.height = new_height;
	
			this.crop.setParams();	// DS. this action slows evertything down after several steps
		    }
	        } else {
		    var tooltip;
		    if (this.exporter) 
			tooltip = " (" + this.exporter.GetTooltip() + ")";
		    else
			tooltip = "";

		    this.crop = new Cropper.Img("graph_image", {
    			onEndCrop:  this.onEndCrop(this),
			onCancelCrop: this.onCancelCrop(this),
			onClick: this.onClick(this),
			onDblClick: this.onApply(this),
			onMouseScroll: this.onMouseScroll(this),
			onApplyClick: this.onApply(this),
			onSaveClick: this.onSave(this),
			margins: this.crop_margins,
			allWidth: this.allWidth,
			allHeight: this.allHeight,
			monitorImage: false,
			imageReady: true,
			tooltips: new Object({
			    'apply': translate('Zoom to the Selection'),
			    'save': translate('Export Selected Data') + tooltip
			})
		    });
		}
}


GRAPH.prototype.Update = function(json, forced) {
    if (json.draw) {
	if (this.img) {
	    var doit = 1;

	    if (this.crop) {
		var crop = this.crop;
		if ((crop.selected)||(crop.dragging)||(crop.resizing)||(crop.calcW()>this.allWidth)||(crop.calcH()>this.allHeight)) {
		    if (forced) this.crop.clear();
		    else doit = 0;
		}
	    }


	    
	    if (doit) {
	        this.img.src = adei.GetServiceURL("getimage", "id=" + json.image);

		this.xmin = parseFloat(json.xmin);
		this.xmax = parseFloat(json.xmax);
		this.ymin = parseFloat(json.ymin);
		this.ymax = parseFloat(json.ymax);

		this.xsize = parseFloat(adeiMathPreciseSubstract(this.xmax, this.xmin));
//		alert(this.xsize + " - " + (this.xmax - this.xmin));
		
//		alert(json.xmin + " - " + this.xmin);

//	    x : self.xmin + (self.xmax - self.xmin)*(point.x - self.margins.left) / self.real_width,
//	    y : self.ymax - (self.ymax - self.ymin)*(point.y - self.margins.top) / self.real_height

	    }
	}
    }
}

GRAPH.prototype.SetExportTooltip = function () {
    var tooltip = this.exporter.GetTooltip();
    if ((this.crop)&&(tooltip)) {
	this.crop.setTooltip(new Object({'save': translate("Export Selected Data (%s)", tooltip)}));
    }
}

GRAPH.prototype.NotifyExportSettings = function() {
    this.SetExportTooltip();
}

//GRAPH.prototype.NotificationExport


GRAPH.prototype.AdjustGeometry = function(width, height) {
    domAdjustGeometry(this.frame, width, height - (this.selector?this.selector.offsetHeight:0) - 5, true);
}


/*
GRAPH.prototype.MouseSelection = function(xy) {
    alert(this.start_xy[0] - xy[0]);
}

GRAPH.prototype.MouseStart = function(evt) {
    var xy = domGetMouseOffset(evt);
    this.start_xy = xy;
    return false;
}

GRAPH.prototype.MouseDone = function(evt) {
    var xy = domGetMouseOffset(evt);
    this.MouseSelection(xy);
}

GRAPH.prototype.MouseVisualize = function(evt) {
    var xy = domGetMouseOffset(evt);
    return false;
}
*/