<?php

$TITLE = "";
$MODULES = array("config", "graph", "help");


$EXPORT_FORMATS = array (
	"csv" => array(
	    'title' => "CSV",
	),
	"xls" => array(
	    'title' => "Excel",
	    'handler' => "EXCEL",
	)
);


$READER_DB_TOSKA = array(
	"toska" => array (
	    "title" => _("TOSKA"),
	    "reader" => "DBReader",
	    "driver" => "odbc",
	    "sqldrv" => "mssql",
	    "subdrv" => "FreeTDS",
	    "host" => "itpfmdb1.ka.fzk.de",
	    "port" => 0,
	    "user" => "souren",
	    "password" => '$souren$',
	    "database" => array("womisaDB_repl")
//	    "disconnected" => true
	)
);

if (is_array($READER_DB)) $READER_DB = array_merge($READER_DB_TOSKA, $READER_DB);
else $READER_DB = $READER_DB_TOSKA;

$OPTIONS["toska__womisaDB_repl"] = array(
	    "groups" => array(
		"/modul(\d+)/" => 'mda.Wt$LiveData$ModulTest${1}',
		"/strom(\d+)/" => 'Wv$Meda$STROMTEST_SE002$r${1}$ITPFMPXI01$Modul01\$09'
	    ),
	    "tables" => array(
//		"/^.*ModulTest(\d+)$/" => array(
		"/^.*ModulTest(10)$/" => array(
		    'gid' => 'modul${1}',
		    'title' => 'Modul ${1} Hz'
		),
		"/^.*STROMTEST.*r(012).*$/" => array(
		    'gid' => 'strom${1}',
		    'title' => 'StromTest ${1}'
		)
	    ),
	    "columns" => array(
		"time" => "WsDateTimeTicks",
		"data" => "/^((WsCh_\d+)|([^W][^s]))/"
	    ),
	    "timezone" => "Europe/Berlin",
	    "time_module" => "MSTICKS",
//	    "time_options" => -36000000000,			// correction
	    "timesort" => 1,					// 0 - NATURAL, 1 - ASC, -1 - DESC, string whith request
	    "date_limit" => "2008-01-01 00:00:00",		//GMT
//	    "date_limit" => "2008-03-29 21:00:00",		//GMT
	    "min_resolution" => 10,
	    "ignore_subseconds" => false,
	    "optimize_empty_cache" => true,
	    "use_cache_timewindow" => true,
//	    "use_cache_reader" => true,
	    "use_md5_postfix" => true
);


$OPTIONS["toska__womisaDB_repl__modul1000"] = array(
    "min_resolution" => 1,
    "cache_config" => array(
	array("min" => 31536000, "res" => 43200),
	array("min" => 2592000, "res" => 3600),
	array("min" => 604800, "res" => 600),
	array("min" => 86400, "res" => 60),
	array("min" => 7200, "res" => 10),
	array("min" => 600, "res" => 1)
    )
);

$OPTIONS["toska__womisaDB_repl__strom012"] = array(
    "min_resolution" => 1,
    "cache_config" => array(
	array("min" => 31536000, "res" => 43200),
	array("min" => 2592000, "res" => 3600),
	array("min" => 604800, "res" => 600),
	array("min" => 86400, "res" => 60),
	array("min" => 7200, "res" => 10),
	array("min" => 600, "res" => 1)
    )
);


// Enable in release
#    $SOURCE_KEEP_WINDOW = true;

?>